<?php
 /*
   Limph Is Monitoring Pingable Hosts
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once("functionlib.php");
session_start();
authentication(0, 0);   
favicon();

echo "<link rel=stylesheet href=css.php>";

echo "<html><head><title>$sitetitle</title></head>";
echo "<body><h1>$sitetitle: User Settings</h1>";   

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

$update=$_POST['update'];
if($update=="yes"){
  $new1 = dbms_escape_string($_POST['new1']);
  $new2 = dbms_escape_string($_POST['new2']);
  
  $user_id = dbms_escape_string($_SESSION['limphid']);

  $salt = substr($user_id, 0, 2);

  if(($new1)&&($new1==$new2)){
    $insert = crypt($new1, $salt);
    
    $query = "UPDATE users SET pass = '$insert' WHERE id = '$user_id';";
    $result = dbms_query($query);
    echo "<h4>Password updated.</h4>";
  };
  
 };

$user_id = $_SESSION['limphid'];
$query = "SELECT number FROM users WHERE id = '$user_id';";
$result = dbms_query($query);
$line = dbms_fetch_array($result, "NUM");
dbms_free_result($result);
$user_number = $line[0];

//display user info
echo "<h2> Notifications for $user_id</h2>";

$action = dbms_escape_string($_POST['action']);

if($action=="remove"){
  foreach($_POST['hosts'] as $host){
    $query = "DELETE FROM host_notif WHERE host = '$host' AND user = '$user_number';";
    $result = dbms_query($query);
  };
 };

if($action=="allocate"){
  foreach($_POST['hosts'] as $host){
    $query = "SELECT number FROM host_notif ORDER BY number DESC LIMIT 1;";
    $result = dbms_query($query);
    $line = dbms_fetch_array($result, "NUM");
    $notif = $line[0];
    $notif++;
    dbms_free_result($result);
    $query = "INSERT host_notif SET number = '$notif',host = '$host',user = '$user_number';";
    $result = dbms_query($query);
  };
 };

//table
echo "<table border=1 align=center cellpadding=2>";
echo "<tr><td valign=top>";
//left side hosts in user's group
echo "<form action=pass.php method=post>";
echo "<input type=hidden name=action value=remove />";
$query = "SELECT number,host FROM host_notif WHERE user = '$user_number' ORDER BY number ASC;";
$result = dbms_query($query);
echo "List of allocated hosts<br />";
echo "<select name=hosts[] multiple=yes size=10 />";
while($line = dbms_fetch_array($result, "NUM")){
  $query1 = "SELECT name,type,port FROM hosts WHERE number = '{$line[1]}';";
  $result1 = dbms_query($query1);
  $line1 = dbms_fetch_array($result1, "NUM");
  dbms_free_result($result1);
  $displaystring =  "<option value={$line[1]}>{$line1[0]}";
  if($line1[1]=='tcp'){$displaystring .= " - {$line1[2]}";};
  echo $displaystring;
  dbms_free_result($result1);
 };
echo "</select>";
dbms_free_result($result);

//submit to remove
echo "</td><td valign=center>";
echo "<input type=hidden name=user value=$number>";
echo "<input type=submit value=\">\" />";
echo "</form>";

echo "<br /><br /><br /><br />";

//submit to add
echo "<form action=pass.php method=post>";
echo "<input type=hidden name=user value=$number>";
echo "<input type=submit value=\"<\" />";

//right side available hosts not in user's group
echo "</td><td valign=top>";
echo "<input type=hidden name=action value=allocate />";
echo  "List of available hosts<br />";
echo "<select name=hosts[] multiple=yes size=10 />";
$query = "SELECT number,name,type,port FROM hosts ORDER BY name ASC;";
$result = dbms_query($query);
while($line = dbms_fetch_array($result, "NUM")){
  //check against allocated for this host
  $query2 = "SELECT COUNT(number) FROM host_notif WHERE host = '{$line[0]}' AND user = '$user_number';";
  $result2 = dbms_query($query2);
  $line2 = dbms_fetch_array($result2, "NUM");
  dbms_free_result($result2);
  if($line2[0]==0){
    $displaystring = "<option value={$line[0]}>{$line[1]}";
    if($line[2]=='tcp'){$displaystring .= " - {$line[3]}";};
    echo $displaystring;
  };
  dbms_free_result($result1);
 };
echo "</select>";
dbms_free_result($result);
echo "</form>";

echo "</td></tr>";
echo"</table>";



dbms_close($link);

echo "<form action=pass.php method=post>";
echo "<table border=1 align=center>";
echo "<CAPTION>Change Password</CAPTION>";
echo "<tr><td>Enter new password:</td><td><input type=password name=new1 /></td></tr>";
echo "<tr><td>Confirm new password:</td><td><input type=password name=new2 /></td></tr>";
echo "</table>";
echo "<br />";
echo "<input type=hidden name=update value=yes>";
echo "<input type=submit value=Submit />";
echo "</form>";
echo "<br />";

echo "<form action=index.php method=post>";
echo "<input type=submit value=Back />";
echo "</form>";
echo "</html>";

?>
